# generated by datamodel-codegen:
#   filename:  properties_directory/non_scalar/total_energy_contributions.json
#   version:   0.28.5

from __future__ import annotations

from enum import Enum
from typing import Optional

from pydantic import BaseModel, Field


class Name(Enum):
    temperature_entropy = "temperature_entropy"


class ScalarSchema(BaseModel):
    name: Optional[Name] = None
    value: float


class Name226(Enum):
    harris_foulkes = "harris_foulkes"


class ScalarSchema25(BaseModel):
    name: Optional[Name226] = None
    value: float


class Name227(Enum):
    one_electron = "one_electron"


class ScalarSchema26(BaseModel):
    name: Optional[Name227] = None
    value: float


class Name228(Enum):
    hartree = "hartree"


class ScalarSchema27(BaseModel):
    name: Optional[Name228] = None
    value: float


class Name229(Enum):
    exchange = "exchange"


class ScalarSchema28(BaseModel):
    name: Optional[Name229] = None
    value: float


class Name230(Enum):
    exchange_correlation = "exchange_correlation"


class ScalarSchema29(BaseModel):
    name: Optional[Name230] = None
    value: float


class Name231(Enum):
    ewald = "ewald"


class ScalarSchema30(BaseModel):
    name: Optional[Name231] = None
    value: float


class Name232(Enum):
    alphaZ = "alphaZ"


class ScalarSchema31(BaseModel):
    name: Optional[Name232] = None
    value: float


class Name233(Enum):
    atomic_energy = "atomic_energy"


class ScalarSchema32(BaseModel):
    name: Optional[Name233] = None
    value: float


class Name234(Enum):
    eigenvalues = "eigenvalues"


class ScalarSchema33(BaseModel):
    name: Optional[Name234] = None
    value: float


class Name235(Enum):
    PAW_double_counting_correction_2 = "PAW_double-counting_correction_2"


class ScalarSchema34(BaseModel):
    name: Optional[Name235] = None
    value: float


class Name236(Enum):
    PAW_double_counting_correction_3 = "PAW_double-counting_correction_3"


class ScalarSchema35(BaseModel):
    name: Optional[Name236] = None
    value: float


class Name237(Enum):
    hartree_fock = "hartree_fock"


class ScalarSchema36(BaseModel):
    name: Optional[Name237] = None
    value: float


class Name238(Enum):
    total_energy_contributions = "total_energy_contributions"


class Units(Enum):
    kJ_mol = "kJ/mol"
    eV = "eV"
    J_mol = "J/mol"
    hartree = "hartree"
    cm_1 = "cm-1"
    Ry = "Ry"
    eV_atom = "eV/atom"


class TotalEnergyContributionsSchema(BaseModel):
    temperatureEntropy: Optional[ScalarSchema] = Field(None, title="scalar schema")
    """
    product of temperature and configurational entropy
    """
    harrisFoulkes: Optional[ScalarSchema25] = Field(None, title="scalar schema")
    """
    non self-consitent energy based on an input charge density
    """
    oneElectron: Optional[ScalarSchema26] = Field(None, title="scalar schema")
    """
    kinetic + pseudopotential energy
    """
    hartree: Optional[ScalarSchema27] = Field(None, title="scalar schema")
    """
    energy due to coulomb potential
    """
    exchange: Optional[ScalarSchema28] = Field(None, title="scalar schema")
    """
    exchange energy
    """
    exchangeCorrelation: Optional[ScalarSchema29] = Field(None, title="scalar schema")
    """
    exchange and correlation energy per particle
    """
    ewald: Optional[ScalarSchema30] = Field(None, title="scalar schema")
    """
    summation of interaction energies at long length scales due to coloumbic interactions
    """
    alphaZ: Optional[ScalarSchema31] = Field(None, title="scalar schema")
    """
    divergent electrostatic ion interaction in compensating electron gas
    """
    atomicEnergy: Optional[ScalarSchema32] = Field(None, title="scalar schema")
    """
    kinetic energy of wavefunctions in the atomic limit
    """
    eigenvalues: Optional[ScalarSchema33] = Field(None, title="scalar schema")
    """
    sum of one electron energies of kinetic, electrostatic, and exchange correlation
    """
    PAWDoubleCounting2: Optional[ScalarSchema34] = Field(None, title="scalar schema")
    """
    double counting correction 2
    """
    PAWDoubleCounting3: Optional[ScalarSchema35] = Field(None, title="scalar schema")
    """
    double counting correction 3
    """
    hartreeFock: Optional[ScalarSchema36] = Field(None, title="scalar schema")
    """
    hartree-fock contribution
    """
    name: Optional[Name238] = None
    units: Optional[Units] = None
